# -*- coding: utf-8 -*-
from sklearn.feature_extraction.text import CountVectorizer
from sklearn.naive_bayes import MultinomialNB
from sklearn.metrics import confusion_matrix
from sklearn.metrics import accuracy_score
import numpy as np
import io
import string
from random import shuffle


with io.open('train_set_x.csv', 'r', encoding ='utf-8') as f:
	#get rid of first line
	f.readline()
	raw = f.readlines()
	data = []
	for line in raw:
		splitline = line.split(',')
		splitline[1] = string.replace(splitline[1],'\n','')
		splitline[1] = " ".join(splitline[1])
		#new
		splitline[1] = string.replace(splitline[1],' ','')
		
		#only get text and not id
		data += [splitline]
		#print data

with io.open('train_set_y.csv', 'r', encoding ='utf-8') as f:
	#get rid of first line
	f.readline()
	raw = f.readlines()
	yData = []
	for i,line in enumerate(raw):
		splitline = line.split(',')
		splitline[1] = string.replace(splitline[1],'\n','')
		#dont add id because its already there
		data[i] += [splitline[1]]
		
		
with io.open('test_set_x.csv', 'r', encoding ='utf-8') as f:
	#get rid of first line
	f.readline()
	raw = f.readlines()
	testdata = []
	for line in raw:
		splitline = line.split(',')
		splitline[1] = string.replace(splitline[1],'\n','')
		#new
		splitline[1] = string.replace(splitline[1],' ','')
		#only get text and not id
		testdata += [splitline]

#shuffle(data)

#shows how data list is organized:
with io.open('classifier_output.txt', 'w', encoding = 'utf-8') as f:
	for i in range(0,100):
		f.write(u"Id:{} Text:{} Class:{}\n".format(data[i][0],data[i][1],data[i][2]))

##validation set not used for now
train =[]
#val = []
for i in data[0:276516]:
	train += [i[1]]
#for i in data[250000:276516]:
#	val += [i[1]]
	
###################Naive Bayes########################
"""
########Finding P(y)##############
classCount = [0,0,0,0,0]
for i in data[0:276516]:
	classCount[int(i[2])] += 1
	
classProbs = [0.0,0.0,0.0,0.0,0.0]
for idx,i in enumerate(classCount):
	classProbs[idx] = i/(276515 * 1.0)

print classProbs
"""

y = []
#y_true = []
for i in data[0:276516]:
	y += [i[2]]
#for i in data[250000:276516]:
#	y_true += [i[2]]



vectorizer = CountVectorizer(analyzer = "char") # Score 0.789
#vectorizer = CountVectorizer(token_pattern='(?u)\w') Score: 0.77
#vectorizer = CountVectorizer(token_pattern='(?u)[679ghkqvwxyz³ºßàáâãäçèéêëíîïñóôöùúûüýÿąćčďęğľłńňœśŝšťźżž]') Score 0.62

ngrams = vectorizer.fit_transform(train)

#shows the characters analyzed by the vectorizer
with io.open('analyzed characters.txt', 'w', encoding = 'utf-8') as f:
	for i in vectorizer.get_feature_names():
		f.write(i)

###Naive Bayes 2######
"""		
with io.open('characters per class.csv', 'w', encoding = 'utf-8') as f:
	bigLetterCount = []
	f.write(u"Character,c_slovak,c_french,c_spanish,c_german,c_polish\n")
	for i,c in enumerate(vectorizer.get_feature_names()):
		letterCount = [0,0,0,0,0]
		for sentence in range(0,276516):
			letterCount[int(data[sentence][2])] += ngrams[sentence,i]
		bigLetterCount += [letterCount]
		f.write(u"{},{},{},{},{},{}\n".format(c,letterCount[0],letterCount[1],letterCount[2],letterCount[3],letterCount[4]))
	#print bigLetterCount
"""		


#validation = vectorizer.transform(val)
#classification
names = "Naive Bayes\t\t"
clf = MultinomialNB()
clf.fit(ngrams, y)
#y_pred = clf.predict(validation)
testcase = clf.predict(ngrams)

#acc = accuracy_score(y_true,y_pred)
output = ' {} train%={}'.format(names,accuracy_score(testcase,y))
			
#Show performance of model
print (output)
print (confusion_matrix(y,testcase))


####format output####				
output = []
for i,t in enumerate(testdata):
	vec = vectorizer.transform([t[1]])
	prediction = clf.predict(vec)
	output += u"{},{}\n".format(i,prediction[0])
###save output###
with io.open('output.csv', 'w', encoding = 'utf-8') as f:
	f.write(u"Id,Category\n")
	for o in output:
		f.write(o)
